Subject: Re: [PATCH] powermac: support G5 CPU hotplug

From: Segher Boessenkool <[email-masked]>
Date: Thu, 3 May 2007 02:17:15 +0200

>>>> Ultimately we want to put the disabled cpus in sleep mode, but that
>>>> will require a suitable cache flush routine.
>>>
>>> I don't have any docs for the particular processors the G5s have, do
>>> they have a sleep mode?
>>
>> They have, but the cache flush is not trivial to do (and might imply
>> access to non documented bits). So let's put that on the to-do list 
>> and
>> stick to NAP for now while I dig something.
>
> Hmmm, I went looking in the 970FX manual for sleep mode and didn't
> find it, only nap and doze...

"Sleep" is a generic term for both "doze" and "nap", heh.

The difference between doze and nap is that in nap mode
the bus interface unit is switched off; on the 970 and
970FX this means that the L2 cache has to be flushed
before entering nap mode (or otherwise snoops will go
missing in action); the 970MP automatically transitions
from nap to doze mode if snoops are requested (and back
to nap again), so no L2 flush is required.  The 970MP
also has a "deep nap" mode which saves more power by
automatically clocking the CPU down.

One more thing -- perhaps keeping the CPU in reset
state saves even more power?

Segher